--[[--------------------------------------------------------------------------------------------------
SUBVENTION
------------------------------------------------------------------------------------------------------
file: subventionModule
author:	Team LTW
start project: 07.12.2017 
------------------------------------------------------------------------------------------------------
Farming Simulator 17
V1.0.0.0 - 06.11.2018

Farming Simulator 19
V1.0.0.0 - 16.05.2019
V1.1.0.0 - 14.08.2019
------------------------------------------------------------------------------------------------------
copyright (c) Team LTW
----------------------------------------------------------------------------------------------------]]
subvention = {}

function subvention:getOwnedFieldSize()
	local fields = 0
	fields = g_farmlandManager.farmlands
	local fieldSize = 0	
	local i = 1
	while i <= #fields do
		if fields[i] ~= nil then
			if fields[i].isOwned == true and g_farmlandManager.farmlandMapping[i] == financeExtent.farmId then
				local fieldArea = fields[i].areaInHa
				if fieldArea > 0 then
					fieldSize = fieldSize + fieldArea
				end
			end
		end	
		i = i + 1
	end
	fieldSize = (math.ceil(fieldSize * 10)) / 10
	return fieldSize
end

function subvention:getSubventionAmount()
	local basicPremium = financeExtent.basicPremium
	local greening = financeExtent.greening
	local firstHa = financeExtent.firstHa			--first 30ha
	local furtherHa = financeExtent.furtherHa		--further 16ha
	local youngFarmer = financeExtent.youngFarmer
	local currentDay = g_currentMission.environment.currentDay
	
	local ownedFieldSize = 0
	ownedFieldSize = self:getOwnedFieldSize()
--print("ownedFieldSize: "..tostring(ownedFieldSize))
			
	local amountBasic = 0		
	amountBasic = (basicPremium + greening) * ownedFieldSize
--print("amountBasic: "..tostring(amountBasic))
	
	local amountFirstHa = 0
	local amountFurtherHa = 0
	local amountSmallFarmer = 0	
	if ownedFieldSize <= 95 then
		if ownedFieldSize <= 30 then
			amountFirstHa = firstHa * ownedFieldSize;
		end
		if ownedFieldSize > 30 and ownedFieldSize <= 46 then
			amountFurtherHa = furtherHa * (ownedFieldSize - 30)
		end	
		amountSmallFarmer = amountFirstHa + amountFurtherHa
	end
--print("amountSmallFarmer: "..tostring(amountSmallFarmer))	
	local amountYoungFarmer = 0
	if	financeExtent.seasons == false then	
		if ownedFieldSize <= 90 and currentDay <= 20 then
			amountYoungFarmer = youngFarmer * ownedFieldSize
		end
	else
		local day = currentDay + g_seasons.environment.currentDayOffset
		local year = g_seasons.environment:yearAtDay(day, seasonLength)
		if ownedFieldSize <= 90 and year <= 4 then		-- 0 = first year
			amountYoungFarmer = youngFarmer * ownedFieldSize
		end
	end

		
--print("amountYoungFarmer: "..tostring(amountYoungFarmer))
	
	local subventionAmount = 0
	subventionAmount = amountBasic + amountSmallFarmer + amountYoungFarmer
--print("subventionAmount:"..tostring(subventionAmount))

	return subventionAmount
end;

function subvention:economicDifficulty()
	local subvention = 0
	local economicDifficulty = g_currentMission.missionInfo.economicDifficulty
	
	if financeExtent.seasons == false then
		if economicDifficulty == 1 then
			subvention = (math.floor ((self:getSubventionAmount() / 2.5) * 100)) / 100
		elseif economicDifficulty == 2 then
			subvention = (math.floor ((self:getSubventionAmount() / 3.33) * 100)) / 100
		elseif economicDifficulty == 3 then
			subvention = (math.floor ((self:getSubventionAmount() / 5) * 100)) / 100
		end
		--print("subvention: "..tostring(subvention));
	else
		if economicDifficulty == 1 then
			subvention = (math.floor((self:getSubventionAmount() * 2) * 100)) / 100
		elseif economicDifficulty == 2 then
			subvention = (math.floor((self:getSubventionAmount() * 1.5) * 100)) / 100
		elseif economicDifficulty == 3 then
			subvention = (math.floor((self:getSubventionAmount() * 100))) / 100
		end
		--print("subvention: "..tostring(subvention))
	end
--print("subvention: "..tostring(subvention))
	return subvention
end

function subvention:enablePayTime()
	if financeExtent.seasons == false then
		if g_currentMission.environment.currentHour == 15 then
			return true
		end
	elseif financeExtent.seasons == true then
		local day = g_currentMission.environment.currentDay + g_seasons.environment.currentDayOffset
		local dayInSeason = g_seasons.environment:dayInSeasonAtDay(day, seasonLength)
		local currentSeason = g_seasons.environment.season
		if dayInSeason == 1 and currentSeason == 0 then
			if g_currentMission.environment.currentHour == 15 then
				return true
			end		
		end
	end
	return false
end;

function subvention:payTime()
	if financeExtent.seasons == false then
		if g_currentMission.environment.currentHour == 16 then	
				return true
		end
	elseif financeExtent.seasons == true then
		if g_currentMission.environment.currentHour == 16 then	
				return true					
		end
	end
	return false
end